
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>聊聊并发-Java中的Copy-On-Write容器 / iVAN</title>

    <meta name="description" content="聊聊并发-Java中的Copy-On-Write容器 Copy-On-Write简称COW,是一种用于程序设计中的优化策略.其基本思路是,从一开始大家都在共享同一个内容,当某个人想要修改这个内容的时候,才会真正把内容Copy出去形成一个新的内容然后再改,这是一种延时懒惰策略.从JDK1.5开始Java并发包里提供了两个使用CopyOnWrite机制实现的并发容器,它们是CopyOnWriteArrayList和CopyOnWriteArraySet.CopyOnWrite容器非常有用,可以在非常多的并发场景中使用到. 什么是CopyOnWrite容">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">聊聊并发-Java中的Copy-On-Write容器</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Copy-On-Write简称COW，是一种用于程序设计中的优化策略。其基本思路是，从一开始大家都在共享同一个内容，当某个人想要修改这个内容的时候，才会真正把内容Copy出去形成一个新的内容然后再改，这是一种延时懒惰策略。从JDK1.5开始Java并发包里提供了两个使用CopyOnWrite机制实现的并发容器,它们是CopyOnWriteArrayList和CopyOnWriteArraySet。CopyOnWrite容器非常有用，可以在非常多的并发场景中使用到。</p>
<h4>什么是CopyOnWrite容器</h4>
<p>CopyOnWrite容器即写时复制的容器。通俗的理解是当我们往一个容器添加元素的时候，不直接往当前容器添加，而是先将当前容器进行Copy，复制出一个新的容器，然后新的容器里添加元素，添加完元素之后，再将原容器的引用指向新的容器。这样做的好处是我们可以对CopyOnWrite容器进行并发的读，而不需要加锁，因为当前容器不会添加任何元素。所以CopyOnWrite容器也是一种读写分离的思想，读和写不同的容器。</p>
<h4>CopyOnWriteArrayList的实现原理</h4>
<p>在使用CopyOnWriteArrayList之前，我们先阅读其源码了解下它是如何实现的。以下代码是向ArrayList里添加元素，可以发现在添加的时候是需要加锁的，否则多线程写的时候会Copy出N个副本出来。</p>
<table>
<tbody>
<tr>
<td><code>01</code></td>
<td>
<code>public</code> <code>boolean</code> <code>add(T e) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>02</code></td>
<td>
<code>    </code><code>final</code> <code>ReentrantLock lock = </code><code>this</code><code>.lock;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>03</code></td>
<td>
<code>    </code><code>lock.lock();</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>04</code></td>
<td>
<code>    </code><code>try</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>05</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>06</code></td>
<td>
<code>        </code><code>Object[] elements = getArray();</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>07</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>08</code></td>
<td>
<code>        </code><code>int</code> <code>len = elements.length;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>09</code></td>
<td>
<code>        </code><code>// 复制出新数组</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>10</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>11</code></td>
<td>
<code>        </code><code>Object[] newElements = Arrays.copyOf(elements, len + </code><code>1</code><code>);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>12</code></td>
<td>
<code>        </code><code>// 把新元素添加到新数组里</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>13</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>14</code></td>
<td>
<code>        </code><code>newElements[len] = e;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>15</code></td>
<td>
<code>        </code><code>// 把原数组引用指向新数组</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>16</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>17</code></td>
<td>
<code>        </code><code>setArray(newElements);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>18</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>19</code></td>
<td>
<code>        </code><code>return</code> <code>true</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>20</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>21</code></td>
<td>
<code>    </code><code>} </code><code>finally</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>22</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>23</code></td>
<td>
<code>        </code><code>lock.unlock();</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>24</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>25</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>26</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>27</code></td>
<td><code>}</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>28</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>29</code></td>
<td>
<code>final</code> <code>void</code> <code>setArray(Object[] a) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>30</code></td>
<td>
<code>    </code><code>array = a;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>31</code></td>
<td><code>}</code></td>
</tr>
</tbody>
</table>
<p>读的时候不需要加锁，如果读的时候有多个线程正在向ArrayList添加数据，读还是会读到旧的数据，因为写的时候不会锁住旧的ArrayList。</p>
<table>
<tbody>
<tr>
<td><code>1</code></td>
<td>
<code>public</code> <code>E get(</code><code>int</code> <code>index) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>2</code></td>
<td>
<code>    </code><code>return</code> <code>get(getArray(), index);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>3</code></td>
<td><code>}</code></td>
</tr>
</tbody>
</table>
<p>JDK中并没有提供CopyOnWriteMap，我们可以参考CopyOnWriteArrayList来实现一个，基本代码如下：</p>
<table>
<tbody>
<tr>
<td><code>01</code></td>
<td>
<code>import</code> <code>java.util.Collection;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>02</code></td>
<td>
<code>import</code> <code>java.util.Map;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>03</code></td>
<td>
<code>import</code> <code>java.util.Set;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>04</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>05</code></td>
<td>
<code>public</code> <code>class</code> <code>CopyOnWriteMap&lt;K, V&gt; </code><code>implements</code> <code>Map&lt;K, V&gt;, Cloneable {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>06</code></td>
<td>
<code>    </code><code>private</code> <code>volatile</code> <code>Map&lt;K, V&gt; internalMap;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>07</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>08</code></td>
<td>
<code>    </code><code>public</code> <code>CopyOnWriteMap() {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>09</code></td>
<td>
<code>        </code><code>internalMap = </code><code>new</code> <code>HashMap&lt;K, V&gt;();</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>10</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>11</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>12</code></td>
<td>
<code>    </code><code>public</code> <code>V put(K key, V value) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>13</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>14</code></td>
<td>
<code>        </code><code>synchronized</code> <code>(</code><code>this</code><code>) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>15</code></td>
<td>
<code>            </code><code>Map&lt;K, V&gt; newMap = </code><code>new</code> <code>HashMap&lt;K, V&gt;(internalMap);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>16</code></td>
<td>
<code>            </code><code>V val = newMap.put(key, value);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>17</code></td>
<td>
<code>            </code><code>internalMap = newMap;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>18</code></td>
<td>
<code>            </code><code>return</code> <code>val;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>19</code></td>
<td>
<code>        </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>20</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>21</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>22</code></td>
<td>
<code>    </code><code>public</code> <code>V get(Object key) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>23</code></td>
<td>
<code>        </code><code>return</code> <code>internalMap.get(key);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>24</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>25</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>26</code></td>
<td>
<code>    </code><code>public</code> <code>void</code> <code>putAll(Map&lt;? </code><code>extends</code> <code>K, ? </code><code>extends</code> <code>V&gt; newData) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>27</code></td>
<td>
<code>        </code><code>synchronized</code> <code>(</code><code>this</code><code>) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>28</code></td>
<td>
<code>            </code><code>Map&lt;K, V&gt; newMap = </code><code>new</code> <code>HashMap&lt;K, V&gt;(internalMap);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>29</code></td>
<td>
<code>            </code><code>newMap.putAll(newData);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>30</code></td>
<td>
<code>            </code><code>internalMap = newMap;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>31</code></td>
<td>
<code>        </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>32</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>33</code></td>
<td><code>}</code></td>
</tr>
</tbody>
</table>
<p>实现很简单，只要了解了CopyOnWrite机制，我们可以实现各种CopyOnWrite容器，并且在不同的应用场景中使用。</p>
<h4>CopyOnWrite的应用场景</h4>
<p>CopyOnWrite并发容器用于读多写少的并发场景。比如白名单，黑名单，商品类目的访问和更新场景，假如我们有一个搜索网站，用户在这个网站的搜索框中，输入关键字搜索内容，但是某些关键字不允许被搜索。这些不能被搜索的关键字会被放在一个黑名单当中，黑名单每天晚上更新一次。当用户搜索时，会检查当前关键字在不在黑名单当中，如果在，则提示不能搜索。实现代码如下：</p>
<table>
<tbody>
<tr>
<td><code>01</code></td>
<td>
<code>package</code> <code>com.ifeve.book;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>02</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>03</code></td>
<td>
<code>import</code> <code>java.util.Map;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>04</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>05</code></td>
<td>
<code>import</code> <code>com.ifeve.book.forkjoin.CopyOnWriteMap;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>06</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>07</code></td>
<td><code>/**</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>08</code></td>
<td>
<code> </code><code>* 黑名单服务</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>09</code></td>
<td>
<code> </code><code>*</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>10</code></td>
<td>
<code> </code><code>* @author fangtengfei</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>11</code></td>
<td>
<code> </code><code>*</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>12</code></td>
<td>
<code> </code><code>*/</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>13</code></td>
<td>
<code>public</code> <code>class</code> <code>BlackListServiceImpl {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>14</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>15</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>CopyOnWriteMap&lt;String, Boolean&gt; blackListMap = </code><code>new</code><code>CopyOnWriteMap&lt;String, Boolean&gt;(</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>16</code></td>
<td>
<code>            </code><code>1000</code><code>);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>17</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>18</code></td>
<td>
<code>    </code><code>public</code> <code>static</code> <code>boolean</code> <code>isBlackList(String id) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>19</code></td>
<td>
<code>        </code><code>return</code> <code>blackListMap.get(id) == </code><code>null</code> <code>? </code><code>false</code> <code>: </code><code>true</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>20</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>21</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>22</code></td>
<td>
<code>    </code><code>public</code> <code>static</code> <code>void</code> <code>addBlackList(String id) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>23</code></td>
<td>
<code>        </code><code>blackListMap.put(id, Boolean.TRUE);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>24</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>25</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>26</code></td>
<td>
<code>    </code><code>/**</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>27</code></td>
<td>
<code>     </code><code>* 批量添加黑名单</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>28</code></td>
<td>
<code>     </code><code>*</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>29</code></td>
<td>
<code>     </code><code>* @param ids</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>30</code></td>
<td>
<code>     </code><code>*/</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>31</code></td>
<td>
<code>    </code><code>public</code> <code>static</code> <code>void</code> <code>addBlackList(Map&lt;String,Boolean&gt; ids) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>32</code></td>
<td>
<code>        </code><code>blackListMap.putAll(ids);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>33</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>34</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>35</code></td>
<td><code>}</code></td>
</tr>
</tbody>
</table>
<p>代码很简单，但是使用CopyOnWriteMap需要注意两件事情：</p>
<p>1. 减少扩容开销。根据实际需要，初始化CopyOnWriteMap的大小，避免写时CopyOnWriteMap扩容的开销。</p>
<p>2. 使用批量添加。因为每次添加，容器每次都会进行复制，所以减少添加次数，可以减少容器的复制次数。如使用上面代码里的addBlackList方法。</p>
<h4>CopyOnWrite的缺点</h4>
<p>CopyOnWrite容器有很多优点，但是同时也存在两个问题，即内存占用问题和数据一致性问题。所以在开发的时候需要注意一下。</p>
<p><strong>内存占用问题</strong>。因为CopyOnWrite的写时复制机制，所以在进行写操作的时候，内存里会同时驻扎两个对象的内存，旧的对象和新写入的对象（注意:在复制的时候只是复制容器里的引用，只是在写的时候会创建新对象添加到新容器里，而旧容器的对象还在使用，所以有两份对象内存）。如果这些对象占用的内存比较大，比如说200M左右，那么再写入100M数据进去，内存就会占用300M，那么这个时候很有可能造成频繁的Yong GC和Full GC。之前我们系统中使用了一个服务由于每晚使用CopyOnWrite机制更新大对象，造成了每晚15秒的Full GC，应用响应时间也随之变长。</p>
<p>针对内存占用问题，可以通过压缩容器中的元素的方法来减少大对象的内存消耗，比如，如果元素全是10进制的数字，可以考虑把它压缩成36进制或64进制。或者不使用CopyOnWrite容器，而使用其他的并发容器，如<a href="http://ifeve.com/concurrenthashmap/" rel="external nofollow noreferrer">ConcurrentHashMap</a>。</p>
<p><strong>数据一致性问题</strong>。CopyOnWrite容器只能保证数据的最终一致性，不能保证数据的实时一致性。所以如果你希望写入的的数据，马上能读到，请不要使用CopyOnWrite容器。</p>
<p>关于C++的STL中，曾经也有过Copy-On-Write的玩法，参见陈皓的《<a href="http://blog.csdn.net/haoel/article/details/24058" rel="external nofollow noreferrer">C++ STL String类中的Copy-On-Write</a>》，后来，因为有很多线程安全上的事，就被去掉了。</p>
<p>文章转自 <a href="http://ifeve.com/java-7-a-comprehensive-tutorial-1-1/#more-12688" rel="external nofollow noreferrer">并发编程网-ifeve.com</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 22:17:09</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8/" title="容器">容器</a>, <a href="https://www.iamivan.net/tag/lock/" title="lock">lock</a>, <a href="https://www.iamivan.net/tag/arraylist/" title="arraylist">arraylist</a>, <a href="https://www.iamivan.net/tag/hashmap/" title="hashmap">hashmap</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>聊聊并发-Java中的Copy-On-Write容器的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5o58Bb.html" rel="bookmark">聊聊并发（二）Java SE1&period;6中的Synchronized</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文属作者原创,原文发表于InfoQ:http://www.infoq.com/cn/articles/java-se-16-synchronized 1 引言 在多线程并发编程中Synchronized一直是元老级角色,很多人都会称呼它为重量级锁,但是随着Java SE1.6对Synchronized进行了各种优化之后,有些情况下它并不那么重了,本文详细介绍了Java SE1.6中为了减少获得锁和释放锁带来的性能消耗而引入的偏向锁和轻量级锁,以及锁的存储结构和升级过程. 2 术语定义 术语 英			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBkYDAM.html" rel="bookmark">深入解析Java并发程序中线程的同步与线程锁的使用&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				synchronized关键字 synchronized,我们谓之锁,主要用来给方法.代码块加锁.当某个方法或者代码块使用synchronized时,那么在同一时刻至多仅有有一个线程在执行该段代码.当有多个线程访问同一对象的加锁方法/代码块时,同一时间只有一个线程在执行,其余线程必须要等待当前线程执行完之后才能执行该代码段.但是,其余线程是可以访问该对象中的非加锁代码块的. synchronized主要包括两种方法:synchronized 方法.synchronized 块. synchron			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo3Dvjb.html" rel="bookmark">浅析Java中CopyOnWrite容器的并发机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Copy-On-Write简称COW,是一种用于程序设计中的优化策略.其基本思路是,从一开始大家都在共享同一个内容,当某个人想要修改这个内容的时候,才会真正把内容Copy出去形成一个新的内容然后再改,这是一种延时懒惰策略.从JDK1.5开始Java并发包里提供了两个使用CopyOnWrite机制实现的并发容器,它们是CopyOnWriteArrayList和CopyOnWriteArraySet.CopyOnWrite容器非常有用,可以在非常多的并发场景中使用到. 什么是CopyOnWrite容			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M91vdRM.html" rel="bookmark">Active Object并发模式在Java中的应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介:Active Object 是并发编程实践中典型的设计模式,Active Object 模式的核心是通过解耦合 方法的调用与执行来提高程序的并发度.本文将从典型 Active Object 设计模式入手,从一个新的视角 来探讨 Active Object 并发模式在 Java 中的应用. 本文主要从以下两个方面进行阐述: 使用 C++ 语言,来描述 Active Object 设计模式. Java 类库对于这样一个典型的模式做了很好的类库层面的封装,因此对于 Java 的开发者来说,很多			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1lXnKb.html" rel="bookmark">重复-java 中 ReentrantLock 高并发响应时间控制性能问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java 中 ReentrantLock 高并发响应时间控制性能问题 如题,具体文案请移步--java 中 ReentrantLock 高并发响应时间控制性能问题 解决方案 http://my.oschina.net/hosee/blog/615865			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeRrNjb.html" rel="bookmark">从源代码的角度聊聊java中StringBuffer、StringBuilder、String中的字符串拼接</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				长久以来,我们被教导字符串的连接最好用StringBuffer.StringBuilder,但是我们却不知道这两者之间的区别.跟字符串相关的一些方法中总是有CharSequence.StringBuffer.StringBuilder.String,他们之间到底有什么联系呢? 1.从类的定义看CharSequence.StringBuffer.StringBuilder.String的关系 下面先贴上这四者的定义(来自JDK1.6) CharSequence是一个定义字符串操作的接口,Strin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWleQEp.html" rel="bookmark">java线程-java中的多线程？线程的并发问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java中的多线程?线程的并发问题 多线程具体代表java中程序的什么?它指的实际功能上的什么情况?详细求解 解决方案 多线程和进程的关系详解: 1.当我们运行QQ程序时,操作系统就会为这个程序创建一个QQ进程(QQ~PCB)并且分配CPU.内存等资源. 2.但这个进程中包含着:发送大型的线程.接受文件的线程.发送文字信息的线程.发送文字信息的线程等多个不同功能的线程. 因而我们才能一边发送文件,一边发送文字信息同时操作.这些线程都共享着QQ进程中的CPU.内存等资源. 总结:所以说进			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmK5L5b.html" rel="bookmark">聊聊 Java 中 HashMap 初始化的另一种方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果你接触过不同的语言,从语法和代码层面来说,Java 是一种不折不扣的&quot;臃肿.啰嗦&quot;的语言,从另一方面来说这种臃肿和啰嗦也体现了它严谨的一面,作为适合构建大型.复杂项目的理由之一. 1.HashMap 初始化的文艺写法 HashMap 是一种常用的数据结构,一般用来做数据字典或者 Hash 查找的容器.普通青年一般会这么初始化: HashMap&lt;String, String&gt; map = new HashMap&lt;String, String&gt;(); map.p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5RPo7z.html" rel="bookmark">Java中不同的并发实现的性能比较</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接   作者:Alex Zhitnitsky   译者:有孚 Fork/Join框架在不同配置下的表现如何? 正如即将上映的星球大战那样,Java 8的并行流也是毁誉参半.并行流(Parallel Stream)的语法糖就像预告片里的新型光剑一样令人兴奋不已.现在Java中实现并发编程存在多种方式,我们希望了解这么做所带来的性能提升及风险是什么.从经过260多次测试之后拿到的数据来看,还是增加了不少新的见解的,这里我们想和大家分享一下. ExecutorService vs. Fork/J			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrnZxM.html" rel="bookmark" class="title">推荐搜索和知识搜索 你会选用哪一个</a>
					<div>
						互联网的争端不仅在网站之间,也在与网站的自身产品之间.搜索引擎其实就是网站的产品,或者说一个功能.搜索引擎之间的争夺就是产品之间的争夺,他们不仅是这两个产品之间的争夺,也是背后的两个网站的争夺.随着信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJlJqM.html" rel="bookmark" class="title">轻松设置让Win2000达到最佳性能</a>
					<div>
						5.当碎片整理过程完成后,选择下一个要进行碎片整理的卷(如果有其它卷的话),直至所有卷碎片整理及合并完毕. 了解颜色代码显示图 &quot;磁盘碎片整理&quot;使用颜色代码系统来显示卷中不同文件类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jEvNb.html" rel="bookmark" class="title">Python中编写函数将数据库内容导入到EXCEL</a>
					<div>
						继Python将数据库数据导入到EXCEL文章之后,这次来一个推进版,将其编写为函数,接着是class.哈哈.. 问过群里的朋友,他们大多采用工具将数据导入到excel,本人以前是用select .. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWKanp.html" rel="bookmark" class="title">常用25条Excel技巧</a>
					<div>
						  很多朋友用Excel处理表格,在使用过程中会遇到各种各样的问题,下面我们为大家整理了25条Excel技巧 ,希望对大家有所帮助.也希望大家认真学习Excel. 1.两列数据查找相同值对应的位置 = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBlQNz.html" rel="bookmark" class="title">乐视云盘如何传到百度云</a>
					<div>
						  乐视云盘文件传到百度云方法. 由于百度云盘和乐视云盘是完全不同的两种云网盘,两者之间无法做到互通互存.换句话说就是,百度云盘中的文件无法直接转存到乐视云盘里面. [解决方法] 1.下载乐视云盘中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGejwb.html" rel="bookmark" class="title">电脑显示屏倒过来了怎么办&quest;电脑显示屏倒立修复还原方法</a>
					<div>
						  有时是不是无意中发现自己电脑(无论台式机还是笔记本)的屏幕倒转过来了呢?如果还用这本身的电脑去查找方法,并一步步的设置,太麻烦了,那么电脑显示屏倒过来了怎么办?下面就为大家介绍电脑显示屏倒立修复还 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWqkyb.html" rel="bookmark" class="title">看看这个常常被初级程序员弄不懂的 &OpenCurlyDoubleQuote;事件&rdquo;</a>
					<div>
						       众所周知在面试中,经常有些崽子面试官会问些&quot;事件和委托&quot;的关系,也许一路走来的程序员大多都会被问到这个,那么对于这个 高频的&quot;事件和委托&quot;问题,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaNBWz.html" rel="bookmark" class="title">django rest&lowbar;framework中将json输出字符强制为utf-8编码</a>
					<div>
						最近在和日本外包合作开发JIRA对接发布系统的版本单时, 遇到这个问题. 就是我们这边的输出浏览器显示为中文,而到了JIRA端就出现乱码. 查了文档,原来django rest_framework的默 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAVqOM.html" rel="bookmark" class="title">企业社会责任成为2007年互联网大会主旋律</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 中国经济的快速发展促使越来越多的企业开始思索企业社会责任的问题,同样,企业社会责任也在2007中国互联网大会上受到热议.在中国经济昂首疾行以及全球经济日 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdENdAz.html" rel="bookmark" class="title">Activiti实战&period; 3&period;3基于Eclipse插件的流程设计器Activiti Designer</a>
					<div>
						3.3基于Eclipse插件的流程设计器Activiti Designer 在客户的需求确定之后,由业务人员利用Activiti Modeler设计完业务流程,此时可以将设计结果导出为bpmn20.x ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr2qrM.html" rel="bookmark" class="title">东航与中国电信合作推出国内首个卫星宽带机上WiFi</a>
					<div>
						体验用户利用机上WiFi刷微信朋友圈.图/CFP 昨天上午,东航与中国电信合作推出的国内首个卫星宽带机上WiFi在上海-北京往返航线上进行了首次商业测试飞行,标志着空中互联网业务开始向民航旅客开放服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWBZjp.html" rel="bookmark" class="title">android-如何显示对话框的加载进度</a>
					<div>
						问题描述 如何显示对话框的加载进度 我使用下面的代码来加载一个URL URL url = new URL(urlstr); HttpURLConnection connection = (HttpUR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNj10yM.html" rel="bookmark" class="title">Bootstrap&amp;lt&semi;基础二&amp;gt&semi; 网格系统</a>
					<div>
						原文:Bootstrap&lt;基础二&gt; 网格系统 Bootstrap 提供了一套响应式.移动设备优先的流式网格系统,随着屏幕或视口(viewport)尺寸的增加,系统会自动分为最多12列. 什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRjv6b.html" rel="bookmark" class="title">数据库&amp;quot&semi;负载均衡&comma;备份&comma;异地容灾&amp;quot&semi;设计</a>
					<div>
						数据库&quot;负载均衡,备份,异地容灾&quot;设计 Author: DigoalPS - 纯属个人看法,仅供参考. 1. 数据对象按分类放到不同的SCHEMA  为了方便实施数据库层面的备份和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRok5b.html" rel="bookmark" class="title">没有原创内容我们怎么做SEO？</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 现在网站已经到了内容为王的时代,当 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDe7nrb.html" rel="bookmark" class="title">贝特瑞签约8Manage 提升企业采购效益</a>
					<div>
						近日,深圳市贝特瑞新能源材料股份有限公司成功与8Manage签约,将上线8Manage SPM(采购与供应商管理系统)解决企业在工程管理中的采购问题,实现采购.审批.供应商.询价等一体化管理,提升企业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b228qZb.html" rel="bookmark" class="title">傲游手机浏览器v2&period;4&period;9四大亮点</a>
					<div>
						相似的经历成就相知的我们,不同的祝福要送给与众不同的你,在这个特殊的日子里,傲游手机浏览器v2.4.9携四大亮点祝福所有女性朋友节日快乐! 亮点1:地址栏随传随到 &amp;http://www.al ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBZ7az.html" rel="bookmark" class="title">请问不写代码vb2005能向表里添加带有自动编号的记录吗？</a>
					<div>
						问题描述 我刚开始学习vb2005,在sql2005中建了一个表,带有自动编号的字段,然后做一个窗体,用bindingnavigator控件结合dataset,直接向数据表里添加记录,没有写代码,可由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWwj8z.html" rel="bookmark" class="title">能够让事情变得更好的人</a>
					<div>
						原标题:真正的人才,不是能够评判是非.指出对错的人,而是能够让事情变得更好的人 我在加利福尼亚大学洛杉矶分校就学的时候,同许多攻读博士学位的学生一样,对自己的聪明财智以及对社会状况的深刻洞察力充满了自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPl15qp.html" rel="bookmark" class="title">用PHP为SHOPEX增加日志功能代码&lowbar;php技巧</a>
					<div>
						尤其像知道哪些蜘蛛对本站进行了访问,访问的频度,页面,普通的站点统计都是无法解决的. 虽然我对PHP了解的很少,但是凭借.NET的开发经验,借助百度仍然很快的完成了,虽然简单,大家莫笑. 复制代码 代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZkqZb.html" rel="bookmark" class="title">微信公众号模板消息群发php实例代码</a>
					<div>
						微信模板消息只能发给一个人,如果要群发,需要通过php循环,依次发送. 注意,如果模板消息发信息时有时无,不稳定,可能你的access_token令牌更新缓存不及时,过期了.可以根据日志文件查看.建议 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnEYvp.html" rel="bookmark" class="title">javascript中通用的表单验证函数</a>
					<div>
						Check.js JS函数文件  代码如下 复制代码 ///////////////////////////////////////////////////////////////////////// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkBAJM.html" rel="bookmark" class="title">Swift游戏开发之俄罗斯方块：No&period;5 Block Party</a>
					<div>
						我实在想不出怎么才能起一个好听点的中文名字,还是用原教程中的名字,block party吧 如果前面的几篇教程你觉得很简单,那么是时候开始加深难度了. 在俄罗斯方块游戏中,我们的主体就是那些形状,而每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Y2BDp.html" rel="bookmark" class="title">z index-二菜单挡上不能正常显示</a>
					<div>
						问题描述 二菜单挡上不能正常显示 前台,当鼠标移到主菜单上显示二菜单,二菜单显示被div挡上了,z-index为什么没有作用啊?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWv18p.html" rel="bookmark" class="title">关于aspx&comma; activex&comma; js 如何传递值的问题</a>
					<div>
						问题描述 最近赶鸭上架,大概要搞这么一个东东,搞出一个activeX来读取usbkey里的文件,当然activex是运行在浏览器端的,然后前台的html/aspx需要把这个读取出来的文件通过调用后台的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOW2mQz.html" rel="bookmark" class="title">防止SQL注入攻击</a>
					<div>
						说起防止SQL注入攻击,感觉很郁闷,这么多年了大家一直在讨论,也一直在争论,可是到了现在似乎还是没有定论.当不知道注入原理的时候会觉得很神奇,怎么就被注入了呢?会觉得很难预防.但是当知道了注入原理之后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4QOWb.html" rel="bookmark" class="title">图片-mfc 动态设置菜单 多文档</a>
					<div>
						问题描述 mfc 动态设置菜单 多文档 我想先登录然后登陆成功以后吧那个登录菜单下的登录摁扭设置成不可以点击 就是不可用 该怎么做呢???这个是个多文档程序 解决方案 EnableMenuItemht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjoJK5M.html" rel="bookmark" class="title">江苏电信重视IDC领域 08大会展示重点客户案例</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 在日前在江苏南京圆满闭幕的2008中国互联网大会上,江苏省电信部门对本次大会引起了充分重视印刷了介绍IDC相关业务的非常精美的宣传画册,整个画册以江苏省 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDjAWrM.html" rel="bookmark" class="title">财富2014最受赞赏中国公司：阿里登顶&comma;百度第二</a>
					<div>
						财富2014最受赞赏中国公司排行榜前10名9月25日消息,&lt;财富&gt;中文版今日正式发布2014年&quot;最受赞赏的中国公司&quot;排行榜,阿里重新登顶全明星榜,百度 名列第二,华为进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M19k5rM.html" rel="bookmark" class="title">微博世界杯大战烽烟四起博友花样百出有笑有泪</a>
					<div>
						新快报记者 陈杨 实习生 徐金荣 其实,看世界杯不一定要去酒吧,也不能只看电视,微博上的世界杯&quot;论坛大战&quot;早就烽烟四起.这一点,从各博友名字后面的&quot;万国旗&quot;上就 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
